#include<stdio.h>
#include<stdlib.h>
#include <assert.h>
#include "arbreAVL.h"

/* Fonction utilitaire pour recuperer la hauteur d'un arbre
   NB : Renvoie 0 si node est NULL
*/
int height(struct Node *node)
{
  if (!node)
    return 0;
  return node->height;
}

/* Fonction utilitaire renvoyant le maximum de deux entiers
 */
int max(int a, int b)
{
  return (a > b)? a : b;
}

/* Procedure qui recalcule le champs height de node a partir de la
   hauteur de ses noeuds fils
*/
void updateHeight(struct Node *node) {
  // TODO A completer
  // Conseil : combinez les fonction height() et max() pour simplifier le codage de updateHeight()
}

/* Fonction renvoyant le nombre de noeuds dans le sous-arbre node
   NB : Renvoie 0 si l'arbre ne contient pas de noeud
*/
int nbNode(const struct Node* node)
{
  // TODO A completer
  return -1; // TODO Pensez a changer ce return qui a cette valeur de retour pour etre sur que le test unitaire de nbNode echoue.
}

/* Fonction liberant tous les elements du sous-arbre node
   (y compris node)
   Renvoie systematiquement NULL
*/
struct Node *release(struct Node *node)
{
  // TODO A completer
  return (struct Node *)0xffffffffffffffff; // TODO Pensez a changer ce return qui a cette valeur de retour pour etre sur que le test unitaire de release echoue.
}

/* Fonction (interne) pour creer un noeud pour stocker la cle
   NB :
      - La cle est recopiee dans une zone memoire allouee dans newNode
      - Les pointeurs left et right sont a NULL
      - Le champ height est initialise a 1 (ce noeud est considere comme 
        une feuille autonome).
*/
static struct Node* newNode(const char *key)
{
  // TODO A completer
  return NULL; // TODO Pensez a changer ce return qui a cette valeur de retour pour etre sur que le test unitaire de insert echoue.
}

/* Fonction recursive qui insere key dans le sous-arbre de racine node.
   Renvoie la nouvelle racine de ce sous-arbre.
   NB : 1) un arbre binaire ne contient jamais deux fois la meme valeur.
           De ce fait, si la valeur existe deja, insert renvoie node, sans creer
           de nouveau noeud.
        2) Si node vaut NULL, renvoie un arbre constitue uniquement d'un noeud
           contenant cet arbre.
*/
struct Node* insert(struct Node* node, const char* key)
{
  // TODO A completer
  return NULL; // TODO Pensez a changer ce return qui a cette valeur de retour pour etre sur que le test unitaire de insert echoue.
}

/* Fonction renvoyant la hauteur de la cle key dans le sous-arbre node.
   NB : Renvoie 0 si la cle n'a pas ete trouvee
*/
int getKeyHeight(struct Node* node, const char *key)
{
  // TODO A completer
  return -1; // TODO Pensez a changer ce return qui a cette valeur de retour pour etre sur que le test unitaire de getKeyHeight echoue.
}

/* Fonction renvoyant le rang de la cle key dans le sous-arbre node.
   Par exemple :
     - Renvoie 0 si le noeud de la cle key est le noeud le plus en bas
       à gauche de l'arbre
     - Renvoie le nombre de noeuds dans l'arbre - 1 si le noeud de la cle
       key est le noeud le plus en bas à droite de l'arbre
   NB : Renvoie -1 si la cle n'a pas ete trouvee
*/
int getKeyRank(const struct Node* node, const char *key)
{
  // TODO A completer
  return -2; // TODO Pensez a changer ce return qui a cette valeur de retour pour etre sur que le test unitaire de getKeyRank echoue.
}

/* Fonction renvoyant la valeur associee a une cle 
   (et NULL si la cle n'est pas trouvee)
*/
char *getValue(struct Node *node, const char *key)
{
  // TODO A completer
  return (char *)0xffffffffffffffff; // TODO Pensez a changer ce return qui a cette valeur de retour pour etre sur que le test unitaire de getValue echoue.
}
